'use strict';

var ClienteServices = angular.module('ClienteServices', []);

ClienteServices.factory('Cliente', ['Conexao',
  (Conexao) => {

    var clienteFactory = {};

    clienteFactory.ValidaCliente = (email, senha, TipoAcesso, callBackFunction) => {
        Conexao.ExecutaService('ValidaCliente', { Email: email, Senha: senha, TipoAcesso: TipoAcesso }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.ClienteSalvar = (cliente, TipoAcesso, callBackFunction) => {
        Conexao.ExecutaService('ClienteSalvar', { clienteJson: cliente, TipoAcesso: TipoAcesso }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.Sair = (callBackFunction) => {
        Conexao.ExecutaService('LogOff', { }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getSessaoValida = (callBackFunction) => {
        Conexao.ExecutaService('getSessaoValida', { }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getClientes = (nome, callBackFunction) => {
        Conexao.ExecutaService('getClientes', { nome: nome }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getCliente = (callBackFunction) => {
        Conexao.ExecutaService('getCliente', {}, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.ClienteUpdate = (cliente, callBackFunction) => {
        Conexao.ExecutaService('ClienteUpdate', {clienteJson: cliente}, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.setAlteraSenha = (senha, callBackFunction) => {
        Conexao.ExecutaService('setAlteraSenha', senha, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.setContatoPage = (contato, callBackFunction) => {
        Conexao.ExecutaService('setContatoPage', contato, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.PrimeiroAcesso = (from, callBackFunction) => {
        Conexao.ExecutaService('PrimeiroAcesso', {OS: 0, latitude: 0, longitude:0, From: from}, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.LocalAcesso = (callBackFunction) => {
        Conexao.ExecutaService('LocalAcesso', { OS: 0, latitude: 0, longitude: 0 }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.PrimeiroAcessoiOS = (callBackFunction) => {
        Conexao.ExecutaService('PrimeiroAcesso', {OS: 2, latitude: 0, longitude:0}, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.LocalAcessoiOS = (callBackFunction) => {
        Conexao.ExecutaService('LocalAcesso', { OS: 2, latitude: 0, longitude: 0 }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getPlanosDegustacao = (callBackFunction) => {
        Conexao.ExecutaService('getPlanosDegustacao', {}, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.setPlanoCampanha = (plano, callBackFunction) => {
        Conexao.ExecutaService('setPlanoCampanha', plano, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getVersaoApp = (callBackFunction) => {
        Conexao.ExecutaService('getVersaoApp', { OS: 0}, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    clienteFactory.getVighaSourcer = (callBackFunction) => {
        Conexao.ExecutaService('getVighaSourcer', {}, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    clienteFactory.trackingPage = (utm_campaign, callBackFunction) => {
        Conexao.ExecutaService('setTrackingPage', { utm_campaign: utm_campaign}, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getPlanoContratado = (params, callBackFunction) => {
        Conexao.ExecutaService('getPlanoContratado', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getPlanoPagamentos = (params, callBackFunction) => {
        Conexao.ExecutaService('getPlanoPagamentos', params, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    clienteFactory.getUsuariosCompartilhado = (params, callBackFunction) => {
        Conexao.ExecutaService('getUsuariosCompartilhado', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getCadastroAsaas = (params, callBackFunction) => {
        Conexao.ExecutaService('getCadastroAsaas', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.setCadastroAsaasService = (params, callBackFunction) => {
        Conexao.ExecutaService('setCadastroAsaasService', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.setContratoCliente = (params, callBackFunction) => {
        Conexao.ExecutaService('setContratoCliente', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.setNotificacaoCliente = (params, callBackFunction) => {
        Conexao.ExecutaService('setNotificacaoCliente', params, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    clienteFactory.setCobrancaContrato = (params, callBackFunction) => {
        Conexao.ExecutaService('setCobrancaContrato', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.delCobrancaContrato = (params, callBackFunction) => {
        Conexao.ExecutaService('delCobrancaContrato', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getCobrancaContrato = (params, callBackFunction) => {
        Conexao.ExecutaService('getCobrancaContrato', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getContratoCliente = (params, callBackFunction) => {
        Conexao.ExecutaService('getContratoCliente', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.finalizaContratoCliente = (params, callBackFunction) => {
        Conexao.ExecutaService('finalizaContratoCliente', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getOfertas = (params, callBackFunction) => {
        Conexao.ExecutaService('getOfertas', params, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    clienteFactory.getDadosCNPJ = (params, callBackFunction) => {
        Conexao.ExecutaService('getDadosCNPJ', params, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    clienteFactory.setClienteDados = (params, callBackFunction) => {
        Conexao.ExecutaService('setClienteDados', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    clienteFactory.getHoraDisponivelAgenda = (params, callBackFunction) => {
        Conexao.ExecutaService('getHoraDisponivelAgenda', params, false,
        (data) => {
            callBackFunction(data);
        });
    }

    clienteFactory.getHoraDisponivelAtendimento = (params, callBackFunction) => {
        Conexao.ExecutaService('getHoraDisponivelAtendimento', params, false,
        (data) => {
            callBackFunction(data);
        });
    }

    clienteFactory.getListaAgendaAtendimento = (params, callBackFunction) => {
        Conexao.ExecutaService('getListaAgendaAtendimento', params, true,
        (data) => {
            callBackFunction(data);
        });
    }

    clienteFactory.setAgendaAtendimento = (params, callBackFunction) => {
        Conexao.ExecutaService('setAgendaAtendimento', params, true,
        (data) => {
            callBackFunction(data);
        });
    }

    clienteFactory.getEmailCadastrado = (email, callBackFunction) => {
        Conexao.ExecutaService('getEmailCadastrado', {Email: email}, true,
        (data) => {
            callBackFunction(data);
        });
    }

    clienteFactory.getSafetyMails = (email, callBackFunction) => {
        callBackFunction({StatusEmail: 'VALIDO'})
        // Conexao.ExecutaServiceExterno(`https://optin.safetymails.com/main/safetyoptin/36e6d454fd12002677dbeeec8cb01e0a54521410/8d3cb8156db3269d6bca6b39fcc2f4c94cb313eb/${btoa(email)}`, false,
        //     (data) => {
        //         callBackFunction(data);
        //     }
        // );
    }

    clienteFactory.setColaboradorCliente = (params, callBackFunction) => {
        Conexao.ExecutaService('setColaboradorCliente', params, true,
            (data) => {
                callBackFunction(data);
            }
        );
    }

    clienteFactory.delColaboradorCliente = (params, callBackFunction) => {
        Conexao.ExecutaService('delColaboradorCliente', params, true,
            (data) => {
                callBackFunction(data);
            }
        );
    }

    clienteFactory.getColaboradoresCliente = (params, callBackFunction) => {
        Conexao.ExecutaService('getColaboradoresCliente', params, true,
            (data) => {
                callBackFunction(data);
            }
        );
    }

    clienteFactory.setColaboradorAdmin = (params, callBackFunction) => {
        Conexao.ExecutaService('setColaboradorAdmin', params, false,
            (data) => {
                callBackFunction(data);
            }
        );
    }

    clienteFactory.getColaboradorByEmail = (params, callBackFunction) => {
        Conexao.ExecutaService('getColaboradorByEmail', params, false,
            (data) => {
                callBackFunction(data);
            }
        );
    }

    clienteFactory.getListaIdioma = (callBackFunction) => {
        Conexao.ExecutaService('getListaIdioma', {}, true,
            (data) => {
                callBackFunction(data);
            }
        );
    }

    clienteFactory.setIdiomaCliente = (params, callBackFunction) => {
        Conexao.ExecutaService('setIdiomaCliente', params, true,
            (data) => {
                callBackFunction(data);
            }
        );
    }

    clienteFactory.validaCodeAad = (params, callBackFunction) => {
        var paramsPost = {
            POST: true,
            data: params
        }
        Conexao.ExecutaService('validaCodeAad', paramsPost, true,
            (data) => {
                callBackFunction(data);
            }
        );
    }

    return clienteFactory;
  }]);
